    'Pocket Image Editor
    'Copyright (C) 2004 Iraklis Psaroudakis

    'This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 
    'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

    'You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Imports System.Text
Imports System.IO
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Collections
Imports System.Resources
Imports Microsoft.VisualBasic
Imports System.Reflection

Public Class frmFillSelection
    Inherits System.Windows.Forms.Form

    Dim WorkingSize As Size
    Public Property FillColor() As Color
        Get
            Return pnlFillColor.BackColor
        End Get
        Set(ByVal Value As Color)
            pnlFillColor.BackColor = Value
        End Set
    End Property
    Public Property ReplaceColor() As Color
        Get
            Return pnlReplaceColor.BackColor
        End Get
        Set(ByVal Value As Color)
            pnlReplaceColor.BackColor = Value
        End Set
    End Property
    Public Property FillAll() As Boolean
        Get
            Return chkFillAll.Checked
        End Get
        Set(ByVal Value As Boolean)
            chkFillAll.Checked = Value
        End Set
    End Property
    Public ImageEdited As Image

    Public Sub New()
        MyBase.New()
        Init()
    End Sub

    Friend WithEvents Menus As New System.Windows.Forms.MainMenu
    Friend WithEvents mnDone As New System.Windows.Forms.MenuItem
    Friend WithEvents mnMenu As New System.Windows.Forms.MenuItem
    Friend WithEvents mnCancel As New System.Windows.Forms.MenuItem
    Friend WithEvents chkFillAll As New System.Windows.Forms.CheckBox
    Friend WithEvents lblFillColor As New System.Windows.Forms.Label
    Friend WithEvents pnlFillColor As New System.Windows.Forms.Panel
    Friend WithEvents pnlFillColorBg As New System.Windows.Forms.Panel
    Friend WithEvents lblReplaceColor As New System.Windows.Forms.Label
    Friend WithEvents pnlReplaceColorBg As New System.Windows.Forms.Panel
    Friend WithEvents mnFillColor As New System.Windows.Forms.MenuItem
    Friend WithEvents mnReplaceColor As New System.Windows.Forms.MenuItem
    Friend WithEvents mnSeperator1 As New System.Windows.Forms.MenuItem
    Friend WithEvents pnlReplaceColor As New System.Windows.Forms.Panel
    Friend WithEvents mnHelp As New System.Windows.Forms.MenuItem
    Friend WithEvents SmartphoneBoxPanel As New System.Windows.Forms.Panel

    Sub Init()
        If Not LCase(frmMain.PlatformType).IndexOf(LCase("WindowsPC")) = -1 Then
            WorkingSize = frmMain.SmartphonePanelsSize
            Me.ClientSize = WorkingSize
        Else
            WorkingSize = New Size(System.Windows.Forms.Screen.PrimaryScreen.WorkingArea.Width, System.Windows.Forms.Screen.PrimaryScreen.WorkingArea.Height)
            'WorkingSize = frmMain.SmartphonePanelsSize
            Me.ClientSize = WorkingSize
        End If

        Menus.MenuItems.Add(mnDone)
        Menus.MenuItems.Add(mnMenu)

        mnDone.Text = "Done"

        mnMenu.MenuItems.Add(mnFillColor)
        mnMenu.MenuItems.Add(mnReplaceColor)
        mnMenu.MenuItems.Add(mnSeperator1)
        mnMenu.MenuItems.Add(mnHelp)
        mnMenu.MenuItems.Add(mnCancel)
        mnMenu.Text = "Menu"

        mnFillColor.Text = "Choose 'Fill' Color"

        mnReplaceColor.Text = "Choose 'Replace' Color"

        mnSeperator1.Text = "-"

        mnCancel.Text = "Cancel"

        chkFillAll.Checked = True
        chkFillAll.CheckState = System.Windows.Forms.CheckState.Checked
        chkFillAll.Location = New System.Drawing.Point(4, 4)
        chkFillAll.Size = New System.Drawing.Size(170, 20)
        chkFillAll.Text = "Fill all selection"

        lblFillColor.Location = New System.Drawing.Point(4, 28)
        lblFillColor.Size = New System.Drawing.Size(170, 22)
        lblFillColor.Text = "Fill Color:"

        pnlFillColor.Location = New System.Drawing.Point(78, 30)
        pnlFillColor.Size = New System.Drawing.Size(14, 14)

        pnlFillColorBg.BackColor = System.Drawing.Color.Black
        pnlFillColorBg.Location = New System.Drawing.Point(77, 29)
        pnlFillColorBg.Size = New System.Drawing.Size(16, 16)

        lblReplaceColor.Font = frmMain.LabelFont
        lblReplaceColor.Location = New System.Drawing.Point(4, 48)
        lblReplaceColor.Size = New System.Drawing.Size(152, 80)
        lblReplaceColor.Text = "If 'Fill all selection' is not checked, replace all pixels inside the selection t" & _
        "hat have the following color with the fill color:"

        pnlReplaceColor.Location = New System.Drawing.Point(158, 76)
        pnlReplaceColor.Size = New System.Drawing.Size(14, 14)

        pnlReplaceColorBg.BackColor = System.Drawing.Color.Black
        pnlReplaceColorBg.Location = New System.Drawing.Point(157, 75)
        pnlReplaceColorBg.Size = New System.Drawing.Size(16, 16)

        mnHelp.Text = "Help"

        SmartphoneBoxPanel.Size = frmMain.SmartphonePanelsSize
        SmartphoneBoxPanel.Location = New Point(WorkingSize.Width / 2 - SmartphoneBoxPanel.Width / 2, 0)

        SmartphoneBoxPanel.Controls.Add(pnlReplaceColor)
        SmartphoneBoxPanel.Controls.Add(pnlReplaceColorBg)
        SmartphoneBoxPanel.Controls.Add(lblReplaceColor)
        SmartphoneBoxPanel.Controls.Add(pnlFillColor)
        SmartphoneBoxPanel.Controls.Add(chkFillAll)
        SmartphoneBoxPanel.Controls.Add(pnlFillColorBg)
        SmartphoneBoxPanel.Controls.Add(lblFillColor)
        Me.Controls.Add(SmartphoneBoxPanel)
        Me.Menu = Menus
        Me.Text = "Fill Selection"
        Me.MaximizeBox = False
        Me.WindowState = System.Windows.Forms.FormWindowState.Normal
        Me.FormBorderStyle = FormBorderStyle.FixedSingle

    End Sub

    Private Sub pnlFillColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pnlFillColor.Click
        mnFillColor_Click(Me, EventArgs.Empty)
    End Sub

    Private Sub pnlReplaceColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pnlReplaceColor.Click
        mnReplaceColor_Click(Me, EventArgs.Empty)
    End Sub

    Private Sub mnDone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnDone.Click
        Me.DialogResult = DialogResult.OK

    End Sub

    Private Sub mnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnCancel.Click
        Me.DialogResult = DialogResult.Cancel
    End Sub

    Private Sub mnFillColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnFillColor.Click
        Dim nColor As New frmColorPicker
        nColor.ImageForPick = ImageEdited
        If nColor.ShowDialog = DialogResult.OK Then
            FillColor = nColor.SelectedColor
        End If
        nColor = Nothing
    End Sub

    Private Sub mnReplaceColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnReplaceColor.Click
        Dim nColor As New frmColorPicker
        nColor.ImageForPick = ImageEdited
        If nColor.ShowDialog = DialogResult.OK Then
            ReplaceColor = nColor.SelectedColor
        End If
        nColor = Nothing
    End Sub

    Private Sub mnHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnHelp.Click ' Help
        System.Windows.Forms.MessageBox.Show("Checking the checkbox allows you to fill all selection with the Fill Color. If the textbox is not checked, then each color (named 'Replace Color') found in the selection will be replaced by the fill color. You can choose the 'Fill Color' & 'Replace Color' by Menu.", "Help", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Asterisk, System.Windows.Forms.MessageBoxDefaultButton.Button1)
    End Sub

End Class

